## LiteralKind

# Enum LiteralKind

Source

    pub enum LiteralKind {
        Int {
            base: Base,
            empty_int: bool,
        },
        Float {
            base: Base,
            empty_exponent: bool,
        },
        Char {
            terminated: bool,
        },
        Byte {
            terminated: bool,
        },
        Str {
            terminated: bool,
        },
        ByteStr {
            terminated: bool,
        },
        CStr {
            terminated: bool,
        },
        RawStr {
            n_hashes: Option<u8>,
        },
        RawByteStr {
            n_hashes: Option<u8>,
        },
        RawCStr {
            n_hashes: Option<u8>,
        },
    }

Expand description

Enum representing the literal types supported by the lexer.

Note that the suffix is not considered when deciding the `LiteralKind` in this type. This means that float literals like `1f32` are classified by this type as `Int`. (Compare against `rustc_ast::token::LitKind` and `rustc_ast::ast::LitKind`).

## Variants§

§

### Int

`12_u8`, `0o100`, `0b120i99`, `1f32`.

#### Fields

§`base: Base`
§`empty_int: bool`
§

### Float

`12.34f32`, `1e3`, but not `1f32`.

#### Fields

§`base: Base`
§`empty_exponent: bool`
§

### Char

`'a'`, `'\\'`, `'''`, `';`

#### Fields

§`terminated: bool`
§

### Byte

`b'a'`, `b'\\'`, `b'''`, `b';`

#### Fields

§`terminated: bool`
§

### Str

`"abc"`, `"abc`

#### Fields

§`terminated: bool`
§

### ByteStr

`b"abc"`, `b"abc`

#### Fields

§`terminated: bool`
§

### CStr

`c"abc"`, `c"abc`

#### Fields

§`terminated: bool`
§

### RawStr

`r"abc"`, `r#"abc"#`, `r####"ab"###"c"####`, `r#"a`. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`
§

### RawByteStr

`br"abc"`, `br#"abc"#`, `br####"ab"###"c"####`, `br#"a`. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`
§

### RawCStr

`cr"abc"`, “cr#“abc”#“, `cr#"a`. `None` indicates an invalid literal.

#### Fields

§`n_hashes: Option<u8>`

## Trait Implementations§

Source§

### impl Clone for LiteralKind

Source§

#### fn clone(&self) -> LiteralKind

Returns a duplicate of the value. Read more
1.0.0§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
Source§

### impl Debug for LiteralKind

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
Source§

### impl Ord for LiteralKind

Source§

#### fn cmp(&self, other: &LiteralKind) -> Ordering

This method returns an `Ordering` between `self` and `other`. Read more
1.21.0§

#### fn max(self, other: Self) -> Self
where Self: Sized,

Compares and returns the maximum of two values. Read more
1.21.0§

#### fn min(self, other: Self) -> Self
where Self: Sized,

Compares and returns the minimum of two values. Read more
1.50.0§

#### fn clamp(self, min: Self, max: Self) -> Self
where Self: Sized,

Restrict a value to a certain interval. Read more
Source§

### impl PartialEq for LiteralKind

Source§

#### fn eq(&self, other: &LiteralKind) -> bool

Tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0§

#### fn ne(&self, other: &Rhs) -> bool

Tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
Source§

### impl PartialOrd for LiteralKind

Source§

#### fn partial_cmp(&self, other: &LiteralKind) -> Option<Ordering>

This method returns an ordering between `self` and `other` values if one exists. Read more
1.0.0§

#### fn lt(&self, other: &Rhs) -> bool

Tests less than (for `self` and `other`) and is used by the `<` operator. Read more
1.0.0§

#### fn le(&self, other: &Rhs) -> bool

Tests less than or equal to (for `self` and `other`) and is used by the `<=` operator. Read more
1.0.0§

#### fn gt(&self, other: &Rhs) -> bool

Tests greater than (for `self` and `other`) and is used by the `>` operator. Read more
1.0.0§

#### fn ge(&self, other: &Rhs) -> bool

Tests greater than or equal to (for `self` and `other`) and is used by the `>=` operator. Read more
Source§

### impl Copy for LiteralKind

Source§

### impl Eq for LiteralKind

Source§

### impl StructuralPartialEq for LiteralKind

## Auto Trait Implementations§

§

### impl Freeze for LiteralKind

§

### impl RefUnwindSafe for LiteralKind

§

### impl Send for LiteralKind

§

### impl Sync for LiteralKind

§

### impl Unpin for LiteralKind

§

### impl UnwindSafe for LiteralKind

## Blanket Implementations§

§

### impl<T> Any for T
where T: 'static + ?Sized,

§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
§

### impl<T> Borrow<T> for T
where T: ?Sized,

§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
§

### impl<T> CloneToUninit for T
where T: Clone,

§

#### unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dest`. Read more
§

### impl<T> From<T> for T

§

#### fn from(t: T) -> T

Returns the argument unchanged.

§

### impl<T, U> Into<U> for T
where U: From<T>,

§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

§

### impl<T> ToOwned for T
where T: Clone,

§

#### type Owned = T

The resulting type after obtaining ownership.
§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 3 bytes

Size for each variant:

- `Int`: 2 bytes
- `Float`: 2 bytes
- `Char`: 1 byte
- `Byte`: 1 byte
- `Str`: 1 byte
- `ByteStr`: 1 byte
- `CStr`: 1 byte
- `RawStr`: 2 bytes
- `RawByteStr`: 2 bytes
- `RawCStr`: 2 bytes